﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace EZChart
{

    public partial class MainForm : EZ_Builder.UCForms.FormPluginMaster
    {
        private static Form MyForm;
        private static Chart BarChart;
        private static Series ChartSeries1;
        private static Series ChartSeries2;
        private static Series ChartSeries3;
        private static Series ChartSeries4;
        private static int _newChartValue;
        private static string _seriesNameToUpdate;
        public MainForm()
        {
            InitializeComponent();
            MyForm = this;
            BarChart = Controls.Find("chart1", true)[0] as Chart;

            // Set palette3
            BarChart.Palette = ChartColorPalette.SeaGreen;
            // Set title
            BarChart.Titles.Add("EZ Bar Chart");
            // Set Series
            ChartSeries1 = BarChart.Series[0];
            ChartSeries1.Name = "Series1";
            ChartSeries1.ChartType = SeriesChartType.Column;
            ChartSeries1.Points.Add();

            ChartSeries2 = BarChart.Series.Add("Series2");
            ChartSeries2.ChartType = SeriesChartType.Column;
            ChartSeries2.Points.Add();

            ChartSeries3 = BarChart.Series.Add("Series3");
            ChartSeries3.ChartType = SeriesChartType.Column;
            ChartSeries3.Points.Add();

            ChartSeries4 = BarChart.Series.Add("Series4");
            ChartSeries4.ChartType = SeriesChartType.Column;
            ChartSeries4.Points.Add();

        }

        /// This method is called by EZ-Builder when it requests the configuration for your  plugin. 
        /// EZ-Builder will request the configuration when the control is created and when the project is saved.
        /// The data set in this configuration will be serialized and saved in the EZ-Builder user's project.
        /// Custom data may be stored in the STORAGE dictionary.
        /// 
        public override EZ_Builder.Config.Sub.PluginV1 GetConfiguration()
        {

            return base.GetConfiguration();
        }

        /// This method is called by EZ-Builder when a project is loaded or when the control is added to a project.
        /// Set your default data in here!
        /// The configuration from the user's project file will be set using this method.
        /// *Note: The  plugin must call Base.SetConfiguration(cf) in your override. See the example!
        /// Also note that this is a good place to ensure all required configuration data exists.
        /// In the case of a newer version of your  plugin where different configuration data may be required outside of the users configuration file, set it here.
        /// 
        public override void SetConfiguration(EZ_Builder.Config.Sub.PluginV1 cf)
        {
            base.SetConfiguration(cf);
        }

        /// This method is called by EZ-Builder when another control sends a command to this control using the EZ-Script ControlCommand() function.
        /// The available ControlCommand() functions for this control should be returned in the GetSupportedControlCommandsMethodsForSlave() override.
        /// 
        public override void SendCommand(string windowCommand, params string[] values)
        {

            //Has to update / redraw on same thread as created.
            _seriesNameToUpdate = windowCommand;
            _newChartValue = int.Parse(values[0]);
            BarChart.Invoke(new MethodInvoker(chart_refresh));

            //Not sending command to other controls.
            //base.SendCommand(windowCommand, values);
        }
        private static void chart_refresh()
        {
            switch (_seriesNameToUpdate)
            {
                case "Series1":
                    BarChart.Series["Series1"].Points.Clear();
                    BarChart.Series["Series1"].Points.AddXY(0, _newChartValue);
                    break;
                case "Series2":
                    BarChart.Series["Series2"].Points.Clear();
                    BarChart.Series["Series2"].Points.AddXY(0, _newChartValue);
                    break;
                case "Series3":
                    BarChart.Series["Series3"].Points.Clear();
                    BarChart.Series["Series3"].Points.AddXY(0, _newChartValue);
                    break;
                case "Series4":
                    BarChart.Series["Series4"].Points.Clear();
                    BarChart.Series["Series4"].Points.AddXY(0, _newChartValue);
                    break;
            }
        }
        /// This method is called by EZ-Builder for the CHEAT SHEET to receive all available ControlCommand() syntax for this control.
        /// When the ControlCommand() is called for this function, see the SendCommand() override.
        //public override object[] GetSupportedControlCommands()
        //{

        //    return base.GetSupportedControlCommands();
        //}
        public override object[] GetSupportedControlCommands()
        {
            return new object[] { "Series, Value" };
        }

    }
}
